Public Class LCConfig
    Public Const conf_file_name = "lcconfig.cfg"
    Private conf_file As String

    Private mXML As New System.Xml.XmlDataDocument

    Public Event Error_Occured(ByVal e As Exception)

    Public Sub New()
        Try
            If Left(My.Application.Info.DirectoryPath, 1) = "\" Then
                conf_file = My.Application.Info.DirectoryPath & conf_file_name
            Else
                conf_file = My.Application.Info.DirectoryPath & "\" & conf_file_name
            End If
            mXML.Load(conf_file)
        Catch ex As Exception
            RaiseEvent Error_Occured(ex)
        End Try
    End Sub

    Public Function GetSetting(ByVal name As String) As String
        Try
            Dim mNode As Xml.XmlNode = mXML.DocumentElement.SelectSingleNode("settings").SelectSingleNode(name)
            GetSetting = mNode.InnerText
        Catch ex As Exception
            GetSetting = ""
        End Try
    End Function

    Public Function GetVariable(ByVal name As String) As String
        Try
            Dim mNode As Xml.XmlNode = mXML.DocumentElement.SelectSingleNode("variables").SelectSingleNode(name)
            GetVariable = mNode.InnerText
        Catch ex As Exception
            GetVariable = ""
        End Try
    End Function

    Public Sub WriteSetting(ByVal name As String, ByVal value As String)
        Try
            If mXML.DocumentElement.SelectSingleNode("settings").SelectNodes(name).Count > 0 Then
                mXML.DocumentElement.SelectSingleNode("settings").SelectNodes(name).Item(0).InnerText = value
            Else
                Dim mnewelement As Xml.XmlElement = mXML.CreateElement(name)
                mnewelement.InnerText = value
                mXML.DocumentElement.SelectSingleNode("settings").InsertAfter(mnewelement, mXML.DocumentElement.SelectSingleNode("settings").SelectSingleNode(name))
            End If
            'mXML.Save(conf_file)
        Catch ex As Exception
            RaiseEvent Error_Occured(ex)
        End Try
    End Sub

    Public Sub WriteVariable(ByVal name As String, ByVal value As String)
        Try
            If mXML.DocumentElement.SelectSingleNode("variables").SelectNodes(name).Count > 0 Then
                mXML.DocumentElement.SelectSingleNode("variables").SelectNodes(name).Item(0).InnerText = value
            Else
                Dim mnewelement As Xml.XmlElement = mXML.CreateElement(name)
                mnewelement.InnerText = value
                mXML.DocumentElement.SelectSingleNode("variables").InsertAfter(mnewelement, mXML.DocumentElement.SelectSingleNode("settings").SelectSingleNode(name))
            End If
            'mXML.Save(conf_file)
        Catch ex As Exception
            RaiseEvent Error_Occured(ex)
        End Try
    End Sub

    Public Sub Flush()
        Try
            mXML.Save(conf_file)
        Catch ex As Exception
            RaiseEvent Error_Occured(ex)
        End Try
    End Sub
End Class
