'    ,  amx_writexml 
'amx_writexml -   AMX Mod X     
'         XML
'  -   , . -   
' , -   CT   T      .
'
'   : http://vinechka.msk.ru
':   (VinilNavigator aka Vinechka)
Public Class amx_writexml

    Private WithEvents mDownload As New System.Net.WebClient
    Private mXML As New System.Xml.XmlDataDocument
    Private DwnldData As String
    Private mUri As Uri
    Private mURL As String = "http://cs.fluda.net/cur_players.xml"

    Public Structure GameInfo
        Public MapName As String
        Public MaxPlayers As Integer
        Public CTPlayersCount As Integer
        Public TPlayersCount As Integer
        Public CTPlayers() As String
        Public TPlayers() As String
    End Structure

    Public Event GetServerInfoComplete(ByVal ServerInfo)
    Public Event GetServerInfoError(ByVal Err As System.Exception)

    Public ServerInfo As GameInfo

    Public Sub GetServerInfoAsync(ByVal URL As String)
        mURL = URL
        mUri = New UriBuilder(URL).Uri
        mDownload.DownloadDataAsync(mUri)
    End Sub

    Public Sub Cancel()
        If mDownload.IsBusy Then
            mDownload.CancelAsync()
        End If
    End Sub

    Private Sub DwnldComplete(ByVal sender As Object, ByVal e As System.Net.DownloadDataCompletedEventArgs) Handles mDownload.DownloadDataCompleted
        If Not e.Cancelled Then
            Try


                Dim mXML As New System.Xml.XmlDataDocument
                Dim mNode As Xml.XmlNode
                DwnldData = System.Text.Encoding.ASCII.GetString(e.Result)
                mXML.LoadXml(DwnldData)
                mNode = mXML.DocumentElement

                ServerInfo.CTPlayersCount = CInt(mNode.SelectNodes("ctcount").Item(0).InnerText)
                ServerInfo.TPlayersCount = CInt(mNode.SelectNodes("tcount").Item(0).InnerText)
                ServerInfo.MapName = mNode.SelectNodes("mapname").Item(0).InnerText
                ServerInfo.MaxPlayers = CInt(mNode.SelectNodes("maxplayers").Item(0).InnerText)

                If ServerInfo.CTPlayersCount > 0 Then
                    Dim icnt As Integer = 0
                    For icnt = 0 To mNode.SelectNodes("CT").Count - 1
                        ReDim Preserve ServerInfo.CTPlayers(icnt)
                        ServerInfo.CTPlayers(icnt) = mNode.SelectNodes("CT").Item(icnt).InnerText
                    Next
                End If

                If ServerInfo.TPlayersCount > 0 Then
                    Dim icnt As Integer = 0
                    For icnt = 0 To mNode.SelectNodes("TF").Count - 1
                        ReDim Preserve ServerInfo.CTPlayers(icnt)
                        ServerInfo.CTPlayers(icnt) = mNode.SelectNodes("TF").Item(icnt).InnerText
                    Next
                End If

                'Now ready to raise complete event
                RaiseEvent GetServerInfoComplete(ServerInfo)
            Catch ex As Exception
                RaiseEvent GetServerInfoError(ex)
            End Try
        End If
        If Not e Is Nothing Then
            RaiseEvent GetServerInfoError(e.Error)
        End If
    End Sub

    Protected Overrides Sub Finalize()
        If mDownload.IsBusy Then
            mDownload.CancelAsync()
        End If
        MyBase.Finalize()
    End Sub
End Class
